#!/usr/bin/perl
########################################################################
#
# CHINESE COMMUNIST PARTY MEMBER SEARCH UTILITY
# DEC 16. 2020
# 
# VERSION:1.0
#
#
# https://leehempfling.com/
# Lee Hempfling
#
use CGI;
use warnings;
use CGI::Carp qw(warningsToBrowser fatalsToBrowser); 
use Cwd;
use File::Path;
&getdate;
$path = getcwd;
$path = "$path"; # add folder name
$sitename = "";
&GetFormInput;
use Time::Local;
print "Content-type: text/html\n\n";
$start = time;

&header;

if (!$field{'doit'}){
&form;
}elsif ($field{'doit'}){
&process;
}

&footer;

sub form {
print qq~

<form action=index.cgi method=post>
This utility will search the translated list of Chinese Communist Party members.<p>
Depending on your server and time-out settings in your browser this may or may not 'time out'.<P>
For entertainment purposes only &#128526; <P>
Select field to search<br>
Fields not listed are not publicly available from this location.<br>
<select name=gettem>
<option value="">Select One...</option>
<option value="id">id</option>
<option value="name">name</option>
<option value="sex">sex</option>
<option value="ethnicity">ethnicity</option>
<option value="hometown">hometown</option>
<option value="organization">organization</option>
<option value="education">education</option>
</select>
<p>
Search looks inside a field not for a perfect match of the whole field contents.<br>The longer your search string the more accurate the results will be.<p>

<input type=text name="getwhat" value="" placeholder="Search is whole string.">
<input type=hidden name="doit" value="1">
<input type=submit value="SEARCH" class="butm"><p>
    <div class="id box">ID Search: The ID number is simply a counter for the entire collection. (170925) etc...</div>
    <div class="name box">NAME Search: The name search is for personal names such as (Xue Jianfeng) etc...</div>
    <div class="sex box">Sex Search: The sex search is either Male or Female...</div>
    <div class="ethnicity box">Ethnicity Search: The Ethnicity search is like Han or Han Nationality ...</div>
    <div class="hometown box">Hometown Search: Hometown search is city and region names such as Zhejiang, Shanghai and Yinzhou, Ningbo, Zhejiang etc...</div>
    <div class="organization box">Organization Search: Organization is the big one such as Fourth Party Branch of Huangpu District Office Affairs Administration and Community Prosecution Branch Committee of the People's Procuratorate of the Huangpu District of the Communist Party of China etc...</div>
    <div class="education box">Education Search: Education search is strange: like: College and Ordinary High School and University etc...</div>
</form>
<script>
\$(document).ready(function(){
    \$("select").change(function(){
        \$(this).find("option:selected").each(function(){
            var optionValue = \$(this).attr("value");
            if(optionValue){
                \$(".box").not("." + optionValue).hide();
                \$("." + optionValue).show();
            } else{
                \$(".box").hide();
            }
        });
    }).change();
});
</script>
~;
}
sub stop {
print qq~I want my search to be <select name=how><option value="loose">loose</option><option value="tight">tight</option></select><p>~;
}
sub process {
$how=$field{'how'};
if ($field{'gettem'}){
 @files = <./data/*.csv>;
 foreach $file (@files) {
 $ft++;
 if ($ft < 11){
 $lookedat++;
open(INFILE,"<$file");
@INFILE=<INFILE>;
close(INFILE);
 $count=@INFILE;
 $rounded = sprintf("%.0f", $count);
 $rounded = commify($rounded);

for $gettem (@INFILE){
	($id,$name,$sex,$ethnicity,$hometown,$organization,$id_card_num,$address,$mobile_num,$phone_num,$education)=split(/\,/,$gettem);
	$id=~ s/\"//ig;
	$name=~ s/\"//ig;
	$sex=~ s/\"//ig;
	$ethnicity=~ s/\"//ig;
	$hometown=~ s/\"//ig;
	$organization=~ s/\"//ig;
	$id_card_num=~ s/\"//ig;
	$address=~ s/\"//ig;
	$mobile_num=~ s/\"//ig;
	$phone_num=~ s/\"//ig;
	$education=~ s/\"//ig;
	$wasit++;
	if ($field{'gettem'} eq "id"){
if ($how ="loose"){
	if ($id =~ /$field{'getwhat'}/ig){$foundthem++;$found.="<td>$id</td><td>$name</td><td>$sex</td><td>$ethnicity</td><td>$hometown</td><td>$organization</td><td>$education</td></tr><tr>";}
}else{
	if ($id = $field{'getwhat'}){$foundthem++;$found .="<td>$id</td><td>$name</td><td>$sex</td><td>$ethnicity</td><td>$hometown</td><td>$organization</td><td>$education</td></tr><tr>";}	
	}
	}elsif ($field{'gettem'} eq "name"){
if ($how ="loose"){
	if ($name =~ /$field{'getwhat'}/ig){$foundthem++;$found .="<td>$id</td><td>$name</td><td>$sex</td><td>$ethnicity</td><td>$hometown</td><td>$organization</td><td>$education</td></tr><tr>";}	
}else{
	if ($name  = $field{'getwhat'}){$foundthem++;$found .="<td>$id</td><td>$name</td><td>$sex</td><td>$ethnicity</td><td>$hometown</td><td>$organization</td><td>$education</td></tr><tr>";}		
	}
	}elsif ($field{'gettem'} eq "sex"){
if ($how ="loose"){
	if ($sex =~ /$field{'getwhat'}/ig){$foundthem++;$found .="<td>$id</td><td>$name</td><td>$sex</td><td>$ethnicity</td><td>$hometown</td><td>$organization</td><td>$education</td></tr><tr>";}	
}else{
	if ($sex  = $field{'getwhat'}){$foundthem++;$found .="<td>$id</td><td>$name</td><td>$sex</td><td>$ethnicity</td><td>$hometown</td><td>$organization</td><td>$education</td></tr><tr>";}	
	}
	}elsif ($field{'gettem'} eq "ethnicity"){
if ($how ="loose"){
	if ($ethnicity =~ /$field{'getwhat'}/ig){$foundthem++;$found .="<td>$id</td><td>$name</td><td>$sex</td><td>$ethnicity</td><td>$hometown</td><td>$organization</td><td>$education</td></tr><tr>";}	
}else{
	if ($ethnicity  = $field{'getwhat'}){$foundthem++;$found .="<td>$id</td><td>$name</td><td>$sex</td><td>$ethnicity</td><td>$hometown</td><td>$organization</td><td>$education</td></tr><tr>";}		
	}
	}elsif ($field{'gettem'} eq "hometown"){
if ($how ="loose"){
	if ($hometown =~ /$field{'getwhat'}/ig){$foundthem++;$found .="<td>$id</td><td>$name</td><td>$sex</td><td>$ethnicity</td><td>$hometown</td><td>$organization</td><td>$education</td></tr><tr>";}
}else{
	if ($hometown  = $field{'getwhat'}){$foundthem++;$found .="<td>$id</td><td>$name</td><td>$sex</td><td>$ethnicity</td><td>$hometown</td><td>$organization</td><td>$education</td></tr><tr>";}	
	}	
	}elsif ($field{'gettem'} eq "organization"){
if ($how ="loose"){
	if ($organization =~ /$field{'getwhat'}/ig){$foundthem++;$found .="<td>$id</td><td>$name</td><td>$sex</td><td>$ethnicity</td><td>$hometown</td><td>$organization</td><td>$education</td></tr><tr>";}	
}else{
	if ($organization  = $field{'getwhat'}){$foundthem++;$found .="<td>$id</td><td>$name</td><td>$sex</td><td>$ethnicity</td><td>$hometown</td><td>$organization</td><td>$education</td></tr><tr>";}	
	}
	}elsif ($field{'gettem'} eq "education"){
if ($how ="loose"){
	if ($education =~ /$field{'getwhat'}/ig){$foundthem++;$found .="<td>$id</td><td>$name</td><td>$sex</td><td>$ethnicity</td><td>$hometown</td><td>$organization</td><td>$education</td></tr><tr>";}	
}else{
	if ($education = $field{'getwhat'}){$foundthem++;$found .="<td>$id</td><td>$name</td><td>$sex</td><td>$ethnicity</td><td>$hometown</td><td>$organization</td><td>$education</td></tr><tr>";}		
	}
	}
	}

   }
 }

 
 
 
 
} else {
print qq~You have not selected a field to search.<meta http-equiv="refresh" content="3;url=index.cgi" />~;
}
if ($found){
print qq~
<center style="font-size:18px;font-weight:700;">
$lookedat files searched<p>
Found search results total $foundthem listings for <b>$field{'getwhat'}</b> found in the $field{'gettem'} field.<p>
</center>
<table border=0 cellpadding=0 cellspacing=0 width=80% align=center class="tablet">
<tr><th>ID</th><th>NAME</th><th>SEX</th><th>ETHNICITY</th><th>HOMETOWN</th><th>ORGANIZATION</th><th>EDUCATION</th></tr><tr>
$found</td></tr></table>
~;
}else{
print qq~
Nothing showed up for <b>$field{'getwhat'}</b> in $lookedat files. Try that again. <meta http-equiv="refresh" content="3;url=index.cgi" />
~;
}
}
sub commify {
    my $text = reverse $_[0];
    $text =~ s/(\d\d\d)(?=\d)(?!\d*\.)/$1,/g;
    return scalar reverse $text;
}
sub header {
print qq~
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>$sitename</title>
    <link href="style.css" rel="stylesheet">
<link href='http://fonts.googleapis.com/css?family=Open+Sans:400,600,800' rel='stylesheet' type='text/css'>
    <!-- HTML5 Shim and Respond.js IE8 support of HTML5 elements and media queries -->
    <!--[if lt IE 9]>
      <script src="//oss.maxcdn.com/libs/html5shiv/3.7.0/html5shiv.js"></script>
      <script src="//oss.maxcdn.com/libs/respond.js/1.4.2/respond.min.js"></script>
    <![endif]-->
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/1.11.0/jquery.min.js"></script>
    
  </head>
  <body>

  <div id="mainwrap">
  <div id="header">
  <div id="navigation"><a href="index.cgi" style="color:#ffffff !Important;">Home</a></div>
  <div id="logo"><img border=0 src="logo.png"></div>
  </div>
	<div id="main"> <!-- main wrapper -->
	<div id="contented"> <!-- contended cente#8b0000 -->
~;
}
sub footer {
print qq~
	</div> <!-- /contended cente#8b0000 -->
	</div> <!-- /main wrapper -->
		</div> <!-- /main wrap -->

<div id="footer" ~; 
if ($field{'gettem'})
{
print qq~style="position:relative !Important;float:left !Important; height:120px !Important;"~; 
}else
{
print qq~style="position:absolute !Important;bottom:0px !Important; height:120px !Important;"~;
}
print qq~This Utility will search 10 rather massive csv files. It takes some time. Hang in there.<p>
    <a href="https://leehempfling.com">Written by some guy who's bored</a><br>No copyright. No problems.<br>And if you are China, you shouldn't have let this list go public. Deal with it.
</div>

  </body>
</html>
</div>
~;
}
sub getdate {
my ($hour,$min,$sec,$mday,$mon,$year) = localtime;
$year = $year+1900;
$mon += 1;
if (length($mon)  == 1) {$mon = "0$mon";}
if (length($mday) == 1) {$mday = "0$mday";}
my $today = "$mon-$mday-$year";
}
sub GetFormInput {

	(*fval) = @_ if @_ ;

	local ($buf);
	if ($ENV{'REQUEST_METHOD'} eq 'POST') {
		read(STDIN,$buf,$ENV{'CONTENT_LENGTH'});
	}
	else {
		$buf=$ENV{'QUERY_STRING'};
	}
	if ($buf eq "") {
			return 0 ;
		}
	else {
 		@fval=split(/&/,$buf);
		foreach $i (0 .. $#fval){
			($name,$val)=split (/=/,$fval[$i],2);
			$val=~tr/+/ /;
			$val=~ s/%(..)/pack("c",hex($1))/ge;
			$name=~tr/+/ /;
			$name=~ s/%(..)/pack("c",hex($1))/ge;

			if (!defined($field{$name})) {
				$field{$name}=$val;
			}
			else {
				$field{$name} .= "\0$val";
				
				#if you want multi-selects to goto into an array change to:
				#$field{$name} .= "\0$val";
			}


		   }
		}
return 1;
}